image: node:16
variables:
  STAGING_DOMAIN: 2overconfident-circle-staging.surge.sh
  PRODUCTION_DOMAIN: 2overconfident-circle.surge.sh
stages:
  - build
  # - test
  - deploy staging
  - deploy production
  - production tests
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/

build website:
  stage: build
  script:
    - echo $CI_COMMIT_SHORT_SHA
    - echo $CI_COMMIT_REF_NAME
    - echo $CI_COMMIT_TAG
    - echo $CI_COMMIT_BRANCH
    - npm install
    - npm install -g gatsby-cli
    - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./src/pages/index.js
    - cat ./src/pages/index.js
    - gatsby build
  artifacts:
    paths:
      - ./public

# test artifact:
#   image: alpine
#   stage: test
#   script:
#     - grep -q "Gatsby" ./public/index.html

# test website:
#   image: node
#   stage: test
#   script:
#     - npm install
#     - npm install -g gatsby-cli
#     - gatsby serve &
#     - sleep 20
#     - curl "http://localhost:9000" | grep -q "Gatsby"

deploy staging:
  only:
    - main
  stage: deploy staging
  environment:
    name: staging
    url: http://$STAGING_DOMAIN
  script:
    - npm install --global surge
    - surge --project ./public --domain $STAGING_DOMAIN

deploy production:
  only:
    - main
  when: manual
  allow_failure: false
  image: node
  stage: deploy production
  script:
    - npm install --global surge
    - surge --project ./public --domain $PRODUCTION_DOMAIN

production tests:
  only:
    - main
  image: alpine
  stage: production tests
  script:
    - apk add --no-cache curl
    - curl -s "https://$PRODUCTION_DOMAIN" | grep -q "$CI_COMMIT_SHORT_SHA"
